/$ SerialLib

sersendstr(string s)
{
   int len,i;

   len=strlen(s);
   for(i=0;i<len;i++){
      sersend(substr(s,i,1));
   }
}

sersendarray(pointer p,int len)
{
   int i;

   // debug output
   if(0){
   puts ("sending: ");
   for(i=0;i<len;i++){
      puts(hex(p[i]) + " ");
   }
   puts ("\n");
   }

   for(i=0;i<len;i++){
      sleep(10);
      sersend(p[i]);
   }
}

serrecvarray(pointer s, int max)
{
   int i, c;

   for (i=0;i<max-1;i++) {
      c=serrecv();
      if(c>255) {
         // terminate
         s[i]=0;
         break;
      }
      s[i] = (char)c;
   }
   s[max-1]=0;
   return i;
}